=== debian/changelog ===
flacon (5.4.0-0mx19) mx; urgency=medium

  * Rebuild for MX-19

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 24 Sep 2019 11:08:48 -0400

flacon (5.4.0-0mx17) mx; urgency=medium

  * Rebuild for MX-17

 -- Timothy E. Harris <maintainer@mxrepo.com>  Tue, 24 Sep 2019 10:05:49 -0400

flacon (5.4.0-1xenial) xenial; urgency=low
  * New program release

 -- Alexander Sokolov <sokoloff.a@gmail.com>  Sat, 27 Apr 2019 13:33:10 +0300
