=== debian/control ===
Source: flacon
Section: sound
Priority: extra
Maintainer: Alexander Sokolov <sokoloff.a@gmail.com>
Build-Depends: pkg-config,
    debhelper,
    cmake,
    qtbase5-dev,
    qttools5-dev,
    qttools5-dev-tools,
    pkg-config,
    libuchardet-dev
Standards-Version: 3.9.4
Homepage: https://github.com/flacon/flacon

Package: flacon
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, flac, mac | monkeys-audio
Recommends: vorbis-tools, wavpack, lame, vorbisgain, mp3gain, ttaenc, faac, opus-tools
Description: Audio file splitter and converter
 Flacon extracts individual tracks from one big audio file containing
 the entire album of music and saves them as separate audio files.
 To do this, it uses information from the appropriate CUE file.
