## flacon 12.0.0

=== debian/changelog ===
flacon (12.0.0-1~mx23) mx; urgency=medium

  * Rebuild for MX-23

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 23 Feb 2026 03:30:37 +0000

flacon (12.0.0-1~mx25) mx; urgency=medium

  * Rebuild for MX-25

 -- Timothy E. Harris <maintainer@mxrepo.com>  Mon, 23 Feb 2026 03:12:29 +0000

flacon (12.0.0-1) unstable; urgency=low

  * version number update by debtransform

 -- debtransform <build@opensuse.org>  Mon, 09 Feb 2026 16:45:27 +0000

flacon (12.0.0) unstable; urgency=low
  * New program release

 -- Alexander Sokolov <sokoloff.a@gmail.com> Mon, 09 Feb 2026 19:13:06 +0300
