=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: flacon
 Section: sound
 Priority: extra
-Maintainer: Alexander Sokolov <sokoloff.a@gmail.com>
+Maintainer: Timothy E. Harris <maintainer@mxrepo.com>
+XSBC-Original-Maintainer: Alexander Sokolov <sokoloff.a@gmail.com>
 Build-Depends: pkg-config,
     debhelper,
     cmake,
@@ -9,8 +10,10 @@
     qttools5-dev,
     qttools5-dev-tools,
     pkg-config,
-    libuchardet-dev
-Standards-Version: 3.9.4
+    libuchardet-dev,
+    libtag1-dev,
+    zlib1g-dev
+Standards-Version: 4.6.2
 Homepage: https://github.com/flacon/flacon
 
 Package: flacon
